/* This is  -*- C++ -*-  */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  \file  defs.h
///  \brief Neccessary definitions.
///  \author Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  \date   06.10.2010
///
///  Copyright (C) 2010 Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  Distributed  under  the  terms  of  the  GNU  General  Public  License (GPL)
///  http://www.gnu.org/licenses/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#ifndef DEFS_H_
#define DEFS_H_

enum AlgTypeE {SEMILINEAR=10, LINEAR=11, PERMUTATIONAL=12, PLUSMINUSMONOMIAL=20};

#define MPZ

#ifdef MPZ
#include "gmpxx.h"
typedef  mpz_class My_Long_Int;
#else
typedef unsigned long My_Long_Int;
#endif

#include <limits.h>
#if ( __WORDSIZE == 64 )
/// We must guarantee 64 bit in order to get unique results on different systems!
#define uchar unsigned long
#define MY_UCHAR_MAX  ULONG_MAX
#else
/// We must guarantee 64 bit in order to get unique results on different systems!
#define uchar unsigned long long
#define MY_UCHAR_MAX  ULONG_LONG_MAX
#endif

#define MODLENGTH 8
#define NBITS 64

#if  MY_UCHAR_MAX  != 18446744073709551615ULL
#error "We need 64 bit for the type uchar"
#endif



#endif /* DEFS_H_ */
