/* This is  -*- C++ -*-  */
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///  \file  hashGenerator.h
///  \brief Defines a primitive class to get well-defined hash values.
///  \author Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  \date   2010-09-29
///
///  Copyright (C) 2010 Thomas Feulner <thomas.feulner@uni-bayreuth.de>
///  Distributed  under  the  terms  of  the  GNU  General  Public  License (GPL)
///  http://www.gnu.org/licenses/
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


#ifndef HASHGENERATOR_HPP_
#define HASHGENERATOR_HPP_

#include <vector>
#include "defs.h"

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// \class CodeCan
/// \brief Returns well defined hash values. Used in Node.
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
class HashGenerator
{
private:
	static std::vector<uchar> hash_table;
public:
	static std::vector<uchar>::const_iterator begin(void);
	static void resize(unsigned int size);
	static uchar getHash(unsigned int pos) { return hash_table[pos]; }
	static uchar getHash(const std::vector<unsigned int>& vals,
			const std::vector<unsigned int>::const_iterator& blockIterBeg, const std::vector<unsigned int>::const_iterator& blockIterEnd );

	static uchar getHash(const std::vector<std::vector<unsigned int> >& vals);
};

#endif /*HASHGENERATOR_HPP_*/
